/* Header file for Super grid placement
*/

void DumpSuperGridPlacement( char* place_file, struct s_placer_opts* p_opts );
void ReadSuperGridPlacement( char* place_file );

/*  
*  Cleanup_Outliers() function at the end to make sure all blocks end up inside the final placement location
*  Find_Home() tries to find a home for a block still outside the BB 
*/
void Cleanup_Outliers( struct s_placer_opts* p_opts );
int Find_Home(int blocknum, struct s_placer_opts* s_opts );

/* End David Add Super Grid Idea */

/* Migration of floorplan functions */
/* David Floorplan placement file
*/
typedef struct 
	{
	char name[BUFSIZE];  // Name of the block
	int xFrom;      // X-base coordinate (Bottom left hand corner is (0,0)
	int yFrom;      // Y-base coordinate 
	int xMax;       // Placement Size X
	int yMax;       // Placement Size Y 
	int count;      // Number of CLBs for this type
	int numFreeCLB; // Number of FREE clbs within this area.
	int delta;      // Were there any delta? 1=yes, 0=no
	} fp;
int Find_Element( char* name, fp* floorplan, int num_elements );
void RecountFreeClbsPerFloorplan( fp* floorplan, int num_elements );

/* Structs and functions for incremental placement 
*
*/
typedef struct
{
	char name[BUFSIZE];
	int x;
	int y;
} clb_loc;

void ReadIncrementalFloorplan( char* src_file, fp* floorplan, int num_fp_elems, struct s_placer_opts* p_opts );
void DumpIncrementalFloorplan( char* dest_file );
void DebugPrintFloorplan( fp* floorplan, int num_elem );
