
#define INIT_WIN_SIZE 1;
#define MWIDTH 145    /* width of menu window */
enum congestion_type {NONE, RENT_PER_LUT, RENT_PER_CLB, NET_PER_WIN, NET_PER_LUT, NET_PER_CLB, BOUNDING_BOX, BOUNDING_BOX_AREA, 
	PINS_PER_CLB, PINS_PER_LUT,  ITERATIVE_ROUTE, CHAN_WIDTH};
//enum congestion_type {NONE, RENT_PER_CLB, NET_PER_CLB, BOUNDING_BOX_AREA, ITERATIVE_ROUTE,
//	PINS_PER_CLB, CHAN_WIDTH, RENT_PER_LUT, NET_PER_WIN, NET_PER_LUT, BOUNDING_BOX, PINS_PER_LUT};
	 
enum map_type {EST, REAL, DIFF};

struct int_linked_list {int value; struct int_linked_list *next;}; 

/*Rent map and congestion estimation stuff*/
extern double **rent_lut_conge_map, **rent_clb_conge_map, **net_win_conge_map, **net_lut_conge_map, **net_clb_conge_map; /*[0..nx-1][0..ny-1]*/
extern double	**channel_conge_map, **bounding_box_conge_map, **bounding_box_area_conge_map, **pins_clb_conge_map, **pins_lut_conge_map,
**iterative_route_conge_map;
extern double **rent_lut_conge_image, **rent_clb_conge_image, **net_win_conge_image, **net_lut_conge_image, **net_clb_conge_image; /*[0..nx-1][0..ny-1]*/
extern double	**channel_conge_image, **bounding_box_conge_image, **bounding_box_area_conge_image, **pins_clb_conge_image, **pins_lut_conge_image,
**iterative_route_conge_image, **diff_real_est_conge_image;
extern t_subblock_data *luts_in_clbs;
extern vboolean calced_rent_lut_conge, calced_rent_clb_conge, calced_net_win_conge, calced_net_lut_conge, calced_net_clb_conge, 
calced_channel_conge, calced_bounding_box_conge, calced_bounding_box_area_conge, calced_pins_clb_conge, calced_pins_lut_conge,
iterative_route_mode, calced_iterative_route_conge, ever_calced_iterative_route, compare_real; 
extern enum congestion_type congestion;
extern int window, blend_time, update_conge;
extern double peak_temp, bottom_temp, peak_sat, bottom_sat, blend_rate;
extern char *window_size_string,  *peak_temp_string, *blend_rate_string, *blend_time_string, 
*bottom_temp_string,  *peak_sat_string,  *bottom_sat_string;

extern t_subblock_data *subblock_data_ptr_g; 
extern t_timing_inf timing_inf_g;        
extern struct s_router_opts router_opts_g;
extern struct s_det_routing_arch det_routing_arch_g;
extern t_segment_inf *segment_inf_g; 
extern t_chan_width_dist chan_width_dist_g;
extern vboolean placed, first_display, command_line;
extern float ***net_slack_g, ***net_delay_g;
extern struct s_placer_opts *placer_opts_g;
extern char conge_file_name[BUFSIZE];
extern char congestion_file[BUFSIZE];

extern unsigned int display_width, display_height;  /* screen size */
extern float xmult, ymult;                  /* Transformation factors */

extern enum pic_type pic_on_screen;

extern float *x_clb_left, *y_clb_bottom, clb_width;

extern double minSatStart, minSatEnd, maxSatStart, maxSatEnd, total_est_conge, total_real_conge, minSatReal, maxSatReal;
extern float **place_conge_map;

extern float calc_place_conge(struct s_bb *bb_coords);
extern void init_conge_est(t_subblock_data *subblock_data);
extern void calc_conge();
extern void calc_diff_real_est(double **conge_est_image);
extern void load_congestion();
extern void free_rent_lut_conge();
extern void free_rent_clb_conge();	
extern void free_net_win_conge();	
extern void free_net_lut_conge();	
extern void free_net_clb_conge();
extern void free_bounding_box_conge();
extern void free_bounding_box_area_conge();	
extern void free_channel_conge();
extern void free_pins_clb_conge();	
extern void free_pins_lut_conge();	
extern void free_iterative_route_conge();	
extern void free_int_linked_list(struct int_linked_list **list_head);
extern void int_list_add(struct int_linked_list **list, struct int_linked_list **list_head, int value);






