#!/bin/sh

# Create multiple PBS job scripts and
# submit each one from its own directory.

PWD=`pwd`
TEST_CASE="multi19"
TEST="multi19"
CR="10"
CLUSTER_METHOD="irac"
ARCH="arch_ieee/k=6/N=16/arch_IORAT=8"
LOGFILE_DIR="logfiles/${TEST_CASE}"
LUT_SIZE="6"
CLUSTER_SIZE="16"
INPUTS_PER_CLUSTER="51"

cd $PBS_O_WORKDIR

# clone -  sims
for CCT in clone
do
for CWC in 125 115 110 105 100 90 80 70

# stdev0 -  sims
#for CCT in stdev0
#do
#for CWC in 100 95 85 80 75 70 60 50

# stdev010 -  sims 
#for CCT in stdev010
#do
#for CWC in 165 150 140 130 125 115 100 85
do


echo "Processing TEST_CASE=$TEST_CASE CWC=$CWC"

# Create the logfile name
LOGNAME="${TEST}_${CCT}_${CWC}.log"
PBSNAME="${TEST}_${CCT}_${CWC}.pbs"

# Create PBS file here
##################################################################################
cat > pbsfiles/${PBSNAME} << EOF
#!/bin/sh
#PBS -S /bin/sh

echo "Running on host: " \`hostname\`
cd $PBS_O_WORKDIR
echo "Current working directory is now: " `pwd`

echo "Started at: " \`date\`

perl scripts/ipack_ivpr_mr.pl blif/${CCT}.blif ${CWC} ${ARCH} ${CLUSTER_METHOD} ${TEST_CASE} ${LUT_SIZE} ${CLUSTER_SIZE} ${INPUTS_PER_CLUSTER} ${CR} > $LOGFILE_DIR/${LOGNAME}

echo "Finished at: " \`date\`
EOF
##################################################################################

# Submit job to the PBS queue
#qsub -l walltime=0:30:00 -o $LOGFILE_DIR/${LOGNAME}.log pbsfiles/${PBSNAME}
#qsub -l walltime=4:00:00 -o $LOGFILE_DIR/${LOGNAME}.log pbsfiles/${PBSNAME}
qsub -l walltime=72:00:00 -l mem=1538mb -o $LOGFILE_DIR/${LOGNAME}.log pbsfiles/${PBSNAME}

done

done

